#include <stdio.h>
#include <stdlib.h>
#include <i86.h>
#include <conio.h>
#include "wave32.h"

#define BIOSseg 0x40

unsigned short *HEADptr = ((BIOSseg << 4) + 0x1a);
unsigned short *TAILptr = ((BIOSseg << 4) + 0x1c);
#define HEAD (*HEADptr)
#define TAIL (*TAILptr)

#define bios_kbhit() (HEAD - TAIL)

void DoExit( void )
{
    ShutDownWAVE();
}

void _VideoPrint( char *s, int r, int c )
{
    volatile char *ptr = (char*)(0xb8000 + 160 * r + c*2);
    volatile int i = 0;

    while ( s[i] ) {
        *ptr++ = s[i++];
        *ptr++ = 0x3f;
    }
}

void PrintVolume( int v )
{
    char buf[50];

    sprintf(buf, "Volume: %d%%  ", v );
    _VideoPrint( buf, 15, 0 );
}

main( int argc, char **argv )
{
    volatile int I, Key, Quit = 0, Volume = MAX_VOL_PERCENT;
    wave Wave;

    if ( argc < 2 ) {
        printf( "usage: pwave file.wav.\n");
        return 0;
    }

    atexit(DoExit);
    if ( PowerUpWAVE() == -1 ) exit(-1);

// Load wave

    Wave.ptr = 0;
    if ( LoadWave(argv[1], &Wave) == 0 ) {
        printf("Loading wave %s failed.\n", argv[1]);
        exit(-2);
    } else
        printf("loaded wave %s\n", argv[1]);

// setup wave playback parameters

    SetToWaveParam( &Wave );

// Start playing.

    printf("Press space to play wave or ESC to quit.\n");

    while(!Quit) {

        if ( bios_kbhit()) {

            _disable();
            Key = getch();
            _enable();

            switch(Key) {
                case 27:
                    Quit = 1;
                    break;

                case 'r':
                case 'R':
                // Remove all the sounds playing
                    for( I = 0; I < MIX_SNDS; I ++ ) {
                        RemoveSound(I);
                    }
                    break;

                case 'u':
                case 'U':
                    if ( Volume < MAX_VOL_PERCENT ) Volume ++;
                    PrintVolume(Volume);
                    break;

                case 'd':
                case 'D':
                    if ( Volume > 1 ) Volume --;
                    PrintVolume(Volume);
                    break;

                case ' ':
                    if ( AddSound( &Wave, 0, Volume, 0, 0, 0 ) < 0 ) {
                        printf("Can't play.\n");
                    }
                    break;

                default:
                    break;
            }
        }
    }

    return 0;
}
